<?php

declare(strict_types=1);

namespace Drupal\sm\Transport\DrupalSql\Stamp;

use Drupal\sm\Transport\DrupalSql\MessageId;
use Symfony\Component\Messenger\Stamp\NonSendableStampInterface;

/**
 * A stamp for received messages.
 *
 * @phpstan-import-type DrupalSqlEnvelope from \Drupal\sm\Transport\DrupalSql\Connection
 */
final class ReceivedStamp implements NonSendableStampInterface {

  private function __construct(
    public MessageId $id,
  ) {}

  /**
   * @phpstan-param DrupalSqlEnvelope $data
   */
  public static function createFromData(array $data): static {
    return new static($data['id']);
  }

}
